package main

import (
	"cicv-data-closedloop/aarch64/kinglong/common/config"
	commonInit "cicv-data-closedloop/aarch64/kinglong/common/init"
	commonService "cicv-data-closedloop/aarch64/kinglong/common/service"
	slaveConfig "cicv-data-closedloop/aarch64/kinglong/slave/package/config"
	slaveService "cicv-data-closedloop/aarch64/kinglong/slave/package/service"
	"cicv-data-closedloop/common/config/c_log"
)

// init 初始化函数
func init() {
	//runtime.GOMAXPROCS(1)
	c_log.InitLog("mnt/media/sda1/cicv-data-closedloop/log", "kinglong-master")
	commonInit.Init()
	slaveConfig.InitTcpListener()
	config.InitKillSignalListener(config.CloudConfig.Hosts[1].Ip)
	// 等待重启，接收到重启信号，会把信号分发给以下channel
	go commonService.WaitKillSelf()
}

// main 主函数
func main() {

	// 1 负责打包数据到data目录
	go commonService.BagRecord(config.CloudConfig.Hosts[1].Name)
	// 2 负责监控故障，并修改timeWindow
	go slaveService.PrepareTimeWindowProducerQueue()
	// 3
	go slaveService.RunTimeWindowProducerQueue()
	// 4 排队运行时间窗口
	go commonService.RunTimeWindowConsumerQueue(config.CloudConfig.Hosts[1].Name)

	// 阻塞主线程，等待其他线程执行。
	select {}

}
