package init

import (
	"cicv-data-closedloop/aarch64/pjisuv/common/config"
	"cicv-data-closedloop/aarch64/pjisuv/common/service"
)

func Init() {

	// 初始化本地配置文件（第1处配置，在本地文件）
	config.InitLocalConfig()

	// 初始化Oss连接信息
	config.InitOssConfig()

	// 初始化业务逻辑配置信息，配置文件在oss上（第2处配置，在oss文件）
	config.InitCloudConfig()

	go config.RefreshCloudConfig()

	// 初始化数据闭环平台的配置（第3处配置，在数据闭环平台接口）
	config.InitPlatformConfig()

	// 初始化ros节点
	config.InitRosConfig()

	// 维护data目录缓存的包数量
	go service.BagCacheClean()

	// 磁盘占用过高时根据缓存策略处理copy目录
	go service.DiskClean()

}
