package main

import (
	commonConfig "cicv-data-closedloop/aarch64/pjisuv/common/config"
	commonInit "cicv-data-closedloop/aarch64/pjisuv/common/init"
	commonService "cicv-data-closedloop/aarch64/pjisuv/common/service"
	slaveConfig "cicv-data-closedloop/aarch64/pjisuv/slave/package/config"
	slaveService "cicv-data-closedloop/aarch64/pjisuv/slave/package/service"
	"cicv-data-closedloop/common/config/c_log"
)

// init 初始化函数
func init() {
	//runtime.GOMAXPROCS(1)
	c_log.InitLog("/mnt/media/sda1/cicv-data-closedloop/log/", "pjisuv-slave")
	commonInit.Init()
	slaveConfig.InitTcpListener()
	commonConfig.InitKillSignalListener(commonConfig.CloudConfig.Hosts[1].Ip)
	// 等待重启，接收到重启信号，会把信号分发给以下channel
	go commonService.WaitKillSelf()
}

// main 主函数
func main() {

	// 1 负责打包数据到data目录
	go commonService.BagRecord(commonConfig.CloudConfig.Hosts[1].Name)
	// 2 负责监控故障，并修改timeWindow
	go slaveService.PrepareTimeWindowProducerQueue()
	// 3
	go slaveService.RunTimeWindowProducerQueue()
	// 4 排队运行时间窗口
	go commonService.RunTimeWindowConsumerQueue(commonConfig.CloudConfig.Hosts[1].Name)

	// 阻塞主线程，等待其他线程执行。
	select {}

}
