package entity

type VehicleModel struct {
	ModelLabel string `json:"model_label"`
}

// VehicleDynamics 动力学配置
type VehicleDynamics struct {
	DynamicsMaxspeed              float64 `json:"dynamics_maxspeed"`              // 最大速度（千米/小时）
	DynamicsEnginepower           float64 `json:"dynamics_enginepower"`           // 发动机功率（千瓦）
	DynamicsMaxdecel              float64 `json:"dynamics_maxdecel"`              // 最大减速度（米/秒2）
	DynamicsMaxsteering           float64 `json:"dynamics_maxsteering"`           // 最大减速度（米/秒2）
	DynamicsMass                  float64 `json:"dynamics_mass"`                  // 质量（千克）
	DynamicsFrontsurfaceeffective float64 `json:"dynamics_frontsurfaceeffective"` // 前表面有效面积（平方米）
	DynamicsAirdragcoefficient    float64 `json:"dynamics_airdragcoefficient"`    // 空气阻力系数
	DynamicsRollingresistance     float64 `json:"dynamics_rollingresistance"`     // 滚动阻力系数
	DynamicsWheeldiameter         float64 `json:"dynamics_wheeldiameter"`         // 车轮直径（米）
	DynamicsWheeldrive            string  `json:"dynamics_wheeldrive"`            // 驱动方式
	DynamicsOverallefficiency     float64 `json:"dynamics_overallefficiency"`     // 总效率
	DynamicsDistfront             float64 `json:"dynamics_distfront"`             // 车前距（米）
	DynamicsDistrear              float64 `json:"dynamics_distrear"`              // 车后距（米）
	DynamicsDistleft              float64 `json:"dynamics_distleft"`              // 车左距（米）
	DynamicsDistright             float64 `json:"dynamics_distright"`             // 车右距（米）
	DynamicsDistheight            float64 `json:"dynamics_distheight"`            // 车高（米）
	DynamicsWheelbase             float64 `json:"dynamics_wheelbase"`             // 轴距（米）
}

type VehicleSensors struct {
	Camera []SensorCamera `json:"camera"`
	OGT    []SensorOgt    `json:"OGT"`
}
